???File Path
==========
***...\Models\corporate\CorporateModels.cs


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@  CorporateCustomSelectData  @@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
public class MdlCorporateCustomSelectData : MdlUserAction {

	public long binCorporateCustomSelectDataId { get; set; } = 0;
	[Required()]
	[Display(Name = "Corporate Custom Data")]
	public long binCorporateCustomDataId { get; set; } = 0;
	[Required()]
	[Display(Name = "Customer")]
	public long binCustomerId { get; set; } = 0;
	public string[] artSelectItems { get; set; } = Array.Empty<string>();
	public string strDbArtSelectItems { get; set; } = "";
}

public class MdlReqCorporateCustomSelectData : MdlRequest {

	public MdlCorporateCustomSelectData mdlCorporateCustomSelectData { get; set; } = new MdlCorporateCustomSelectData();
}

public class MdlResCorporateCustomSelectData : MdlResponse {

	public MdlCorporateCustomSelectData mdlCorporateCustomSelectData { get; set; } = new MdlCorporateCustomSelectData();
}

public class MdlResCorporateCustomSelectDataList : MdlResponse {

	public List<MdlCorporateCustomSelectData> lstMdlCorporateCustomSelectData { get; set; } = new List<MdlCorporateCustomSelectData>();
}

public class MdlResCorporateCustomSelectDataInit : MdlResponse {
	public List<MdlBaseIntId> lstMdlCorporateCustomDataBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlCustomerBaseIntId { get; set; } = new List<MdlBaseIntId>();


	public List<MdlCorporateCustomSelectData> lstMdlCorporateCustomSelectData { get; set; } = new List<MdlCorporateCustomSelectData>();
}

