???File Path
==========
***...\Src\Corporate\CorporateCustomSelectData.cs




???Check the points
==================



            // ??? IMPORT:- Add the items top - Duplcation Avoid
            using System;
            using System.Data;
            using System.Collections.Generic;
            using Npgsql;
            using NpgsqlTypes;

            using TAAS.Db;
            using TAAS.Models;
            using TAAS.Models.Corporate;
            using TAAS.Helpers;
        


            // ??? CLASS ATTRIBUTES:- The code past top of the class(Attributes) - Duplcation Avoid
            public GlobalFunctions insGlobalFunctions = new GlobalFunctions();
            DbService insDbService = new();
        


            public List<MdlBaseIntId> FnGetAllCorporateCustomSelectDataBaseData()
            {
                List<MdlBaseIntId> lstMdlCorporateCustomSelectDataBaseIntId = new List<MdlBaseIntId>();

                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_corporate_custom_select_data()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlBaseIntId mdlBaseIntId = new MdlBaseIntId();

                        mdlBaseIntId.binPkId = (DBNull.Value != objRecord["pk_corporate_custom_select_data_id"]) ? (long)Convert.ToUInt64(objRecord["pk_corporate_custom_select_data_id"]) : mdlBaseIntId.binPkId;
                        mdlBaseIntId.strCode = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strCode;
                        mdlBaseIntId.strName = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strName;
        
                        lstMdlCorporateCustomSelectDataBaseIntId.Add(mdlBaseIntId);
                    }
                }

                return lstMdlCorporateCustomSelectDataBaseIntId;
            }
        


            public List<MdlCorporateCustomSelectData> FnGetAllCorporateCustomSelectDataWithActionUser()
            {
                List<MdlCorporateCustomSelectData> lstMdlCorporateCustomSelectData = new List<MdlCorporateCustomSelectData>();
                
                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_corporate_custom_select_data_with_action_user()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlCorporateCustomSelectData mdlCorporateCustomSelectData = new MdlCorporateCustomSelectData();

                        
				mdlCorporateCustomSelectData.binCorporateCustomSelectDataId = (DBNull.Value != objRecord["pk_corporate_custom_select_data_id"]) ? (long)Convert.ToInt64(objRecord["pk_corporate_custom_select_data_id"]) : mdlCorporateCustomSelectData.binCorporateCustomSelectDataId;
				mdlCorporateCustomSelectData.binCorporateCustomDataId = (DBNull.Value != objRecord["fk_corporate_custom_data_id"]) ? (long)Convert.ToInt64(objRecord["fk_corporate_custom_data_id"]) : mdlCorporateCustomSelectData.binCorporateCustomDataId;
				mdlCorporateCustomSelectData.binCustomerId = (DBNull.Value != objRecord["fk_customer_id"]) ? (long)Convert.ToInt64(objRecord["fk_customer_id"]) : mdlCorporateCustomSelectData.binCustomerId;
				mdlCorporateCustomSelectData.artSelectItems = (DBNull.Value != objRecord["art_select_items"]) ? (string[])objRecord["art_select_items"] : mdlCorporateCustomSelectData.artSelectItems;

				mdlCorporateCustomSelectData.intSysActionId = (DBNull.Value != objRecord["int_sys_action_id"]) ? (int)Convert.ToInt32(objRecord["int_sys_action_id"]) : mdlCorporateCustomSelectData.intSysActionId;
				mdlCorporateCustomSelectData.binCreatedUserId = (DBNull.Value != objRecord["fk_created_user_id"]) ? (long)Convert.ToInt64(objRecord["fk_created_user_id"]) : mdlCorporateCustomSelectData.binCreatedUserId;
				mdlCorporateCustomSelectData.strCreatedUser = this.insDbService.FnGetValue(objRecord["vhr_created_user"], mdlCorporateCustomSelectData.strCreatedUser);
				mdlCorporateCustomSelectData.dtmCreated = (DBNull.Value != objRecord["dtm_created"]) ? (DateTime)Convert.ToDateTime(objRecord["dtm_created"]) : mdlCorporateCustomSelectData.dtmCreated;
				mdlCorporateCustomSelectData.binLastModifiedUserId = (DBNull.Value != objRecord["fk_last_modified_user_id"]) ? (long)Convert.ToInt64(objRecord["fk_last_modified_user_id"]) : mdlCorporateCustomSelectData.binLastModifiedUserId;
				mdlCorporateCustomSelectData.strLastModifiedUser = this.insDbService.FnGetValue(objRecord["vhr_last_modified_user"], mdlCorporateCustomSelectData.strLastModifiedUser);
				mdlCorporateCustomSelectData.dtmLastModified = (DBNull.Value != objRecord["dtm_last_modified"]) ? (DateTime)Convert.ToDateTime(objRecord["dtm_last_modified"]) : mdlCorporateCustomSelectData.dtmLastModified;
				mdlCorporateCustomSelectData.binDeletedUserId = (DBNull.Value != objRecord["fk_deleted_user_id"]) ? (long)Convert.ToInt64(objRecord["fk_deleted_user_id"]) : mdlCorporateCustomSelectData.binDeletedUserId;
				mdlCorporateCustomSelectData.strDeletedUser = this.insDbService.FnGetValue(objRecord["vhr_deleted_user"], mdlCorporateCustomSelectData.strDeletedUser);
				mdlCorporateCustomSelectData.dtmDeleted = (DBNull.Value != objRecord["dtm_deleted"]) ? (DateTime)Convert.ToDateTime(objRecord["dtm_deleted"]) : mdlCorporateCustomSelectData.dtmDeleted;

        
                        lstMdlCorporateCustomSelectData.Add(mdlCorporateCustomSelectData);
                    }
                }

                return lstMdlCorporateCustomSelectData;
            }
        


            public MdlResCorporateCustomSelectData FnInsertOrUpdateCorporateCustomSelectData(MdlReqCorporateCustomSelectData mdlReqCorporateCustomSelectData)
            {
                // *** Input Validation INSERT and UPDATE Case[not duplicate model validation]
                // ??? Duplication Checking in DB FUCTION(Insert and Update) - CODE, NAME [, other unique fields] Already exists
                // ??? Count Exced or other checking License related in DB FUCTION(Insert)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)

                // Set Create or modified User in DB FUCTION(Insert, Update and Delete)
                if (mdlReqCorporateCustomSelectData.mdlCorporateCustomSelectData.binCorporateCustomSelectDataId == 0)
                {
                    mdlReqCorporateCustomSelectData.mdlCorporateCustomSelectData.intSysActionId = 0;
                    mdlReqCorporateCustomSelectData.mdlCorporateCustomSelectData.binCreatedUserId = mdlReqCorporateCustomSelectData.linLoginUserId;
                    mdlReqCorporateCustomSelectData.mdlCorporateCustomSelectData.strCreatedUser = mdlReqCorporateCustomSelectData.strLoginUserName;
                    mdlReqCorporateCustomSelectData.mdlCorporateCustomSelectData.dtmCreated = mdlReqCorporateCustomSelectData.dtmCurrentDateTime;
                }
                else {
                    mdlReqCorporateCustomSelectData.mdlCorporateCustomSelectData.binLastModifiedUserId = mdlReqCorporateCustomSelectData.linLoginUserId;
                    mdlReqCorporateCustomSelectData.mdlCorporateCustomSelectData.strLastModifiedUser = mdlReqCorporateCustomSelectData.strLoginUserName;
                    mdlReqCorporateCustomSelectData.mdlCorporateCustomSelectData.dtmLastModified = mdlReqCorporateCustomSelectData.dtmCurrentDateTime;
                }

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("mdlCorporateCustomSelectData", NpgsqlDbType.Jsonb) { Value = mdlReqCorporateCustomSelectData.mdlCorporateCustomSelectData, DataTypeName = "jsnCorporateCustomSelectData"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_insert_or_update_corporateCustomSelectData(:mdlCorporateCustomSelectData, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CORPORATECUSTOMSELECTDATA.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CORPORATECUSTOMSELECTDATA.CS#002", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CORPORATECUSTOMSELECTDATA.CS#003", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Saved
                MdlResCorporateCustomSelectData mdlResCorporateCustomSelectData = new MdlResCorporateCustomSelectData();
                mdlResCorporateCustomSelectData.mdlCorporateCustomSelectData = mdlCorporateCustomSelectDataReq.mdlCorporateCustomSelectData;
                if (mdlReqCorporateCustomSelectData.mdlCorporateCustomSelectData.binCorporateCustomSelectDataId == 0)
                {
                    mdlResCorporateCustomSelectData.mdlCorporateCustomSelectData.binCorporateCustomSelectDataId = mdlDbResponse.binSqlPk ?? 0;
                    mdlResCorporateCustomSelectData.mdlCorporateCustomSelectData.dtmCreated = mdlDbResponse.dtmCurrent;
                }
                else
                {
                    mdlResCorporateCustomSelectData.mdlCorporateCustomSelectData.intSysActionId += 1;
                    mdlResCorporateCustomSelectData.mdlCorporateCustomSelectData.dtmLastModified = mdlDbResponse.dtmCurrent;
                }
                mdlResCorporateCustomSelectData.sinStatus = 1;
                mdlResCorporateCustomSelectData.strStatusCode = "SUCCESS";
                mdlResCorporateCustomSelectData.strMessage = "CORPORATECUSTOMSELECTDATA has been Saved.";
                
                return mdlResCorporateCustomSelectData;
            } 
        


            public MdlResBaseIntId FnDeleteCorporateCustomSelectData(MdlReqBaseIntId mdlReqCorporateCustomSelectDataBaseIntId)
            {
                // *** Input Validation DELETE Case[not duplicate model validation]
                // ??? FOREIGN KEY REFERENCES Ching in DB FUCTION(Delete)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)
                // ??? Set Create or modified User in DB FUCTION(Insert, Update and Delete)

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("binCorporateCustomSelectDataId", NpgsqlDbType.Bigint) { Value = mdlReqCorporateCustomSelectDataBaseIntId.mdlBaseIntId.binPkId, DataTypeName = "binCorporateCustomSelectDataId"},
                    new NpgsqlParameter("intSysActionId", NpgsqlDbType.Integer) { Value = mdlReqCorporateCustomSelectDataBaseIntId.mdlBaseIntId.binCustomValue, DataTypeName = "intSysActionId"},
                    new NpgsqlParameter("binDeletedUserId", NpgsqlDbType.Bigint) { Value = mdlReqCorporateCustomSelectDataBaseIntId.linLoginUserId, DataTypeName = "binDeletedUserId"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_delete_corporateCustomSelectData(:binCorporateCustomSelectDataId, :intSysActionId, :binDeletedUserId, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CORPORATECUSTOMSELECTDATA.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CORPORATECUSTOMSELECTDATA.CS#005", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CORPORATECUSTOMSELECTDATA.CS#006", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Deleted
                MdlResBaseIntId mdlResCorporateCustomSelectDataIntId = new MdlResBaseIntId();

                mdlResCorporateCustomSelectDataIntId.mdlBaseIntId = mdlReqCorporateCustomSelectDataBaseIntId.mdlBaseIntId;
                mdlResCorporateCustomSelectDataIntId.sinStatus = 1;
                mdlResCorporateCustomSelectDataIntId.strStatusCode = "SUCCESS";
                mdlResCorporateCustomSelectDataIntId.strMessage = "CORPORATECUSTOMSELECTDATA has been deleted.";

                return mdlResCorporateCustomSelectDataIntId;
            }
        

